#!/usr/bin/env python

""" Unit Test for the debugging exercise.

SOLUTION

We complete 'test_on_file' and write an additional test for the broken input
string.


"""

import unittest
from convert_to_dict import ConvertToDict

class TestConvertToDict(unittest.TestCase):

    def test_on_string(self):
        ctd = ConvertToDict()
        exemplar = '1234 2345 3456 4567'
        target = {'1': 2345, '0': 1234, '3': 4567, '2': 3456}
        answer = ctd.get_number_dict(exemplar)
        self.assertEqual(target, answer)

    def test_on_file(self):
        ctd = ConvertToDict()
        target_one = {'1': 2345, '0': 1234, '3': 4567, '2': 3456}
        target_two = {'1': 8765, '0': 9876, '3': 6543, '2': 7654}
        file_name = 'working.data'
        line_one, line_two = file(file_name)
        answer_one = ctd.get_number_dict(line_one.strip())
        answer_two = ctd.get_number_dict(line_two.strip())
        self.assertEqual(target_one, answer_one)
        self.assertEqual(target_two, answer_two)

    def test_corrupt_input(self):
        ctd = ConvertToDict()
        exemplar = '1 2 3 4 5 6 7 8 9\x089 10' 
        target = {'1': 2, '0': 1, '3': 4, '2': 3, '5': 6, '4': 5, '7': 8, '6':
                7}
        answer = ctd.get_number_dict(exemplar)
        self.assertEqual(target, answer)



if __name__ == '__main__':
    unittest.main()

